# Comparing Objects

Introduction

Before looking into the capabilities that Memory Analyzer offers in the area of comparison let us make some explanation. Object IDs which are provided in the heap dump formats supported by MAT are just the addresses at which the objects are located. As objects are often moved and reordered by the JVM during a GC these addressed change. Therefore they cannot be used to compare the objects. This basically means that if one compares two different heap dumps (although from the same process) it is not possible to point to the concrete objects different between the two heap dumps. However, one can still perform comparison on the aggregated results (e.g. the class histogram) and analyze how the amount of object and the memory they take has changed.

Memory Analyzer offers the possibility to compare not only the global class histograms of two different heap dumps, but an arbitrary number of table-formatted or tree-formatted results - for example the retained sets of three different objects. It doesn't matter if the tables or trees which are compared come from one and the same or different heap dumps.

This means that one has the possibility to do things like:

- Compare the retained set of a specific package across several heap dumps
- Compare how the retained sets for application objects A1, A2 and A3 (all in the same heap dump) differ from each other

Here is a quick description how to compare several retained set tables.

1. Move all tables to be compared to the Compare Basket

   All queries which are executed in Memory Analyzer can be seen in the Navigation History View. From this view one can add the results to be compared to the Compare Basket. The Navigation History is still per heap dump, therefore if one wants to compare tables from different heap dumps then they have to be added one by one. Multiple tables from one heap dump can be added at a time.

   Trees can be compared as well, and the comparison result is then a tree. Object Query Language (OQL) results can also be compared, though only the last result from each OQL editor can be added to the Compare Basket. If another query is issued then the previous result will be removed from the basket. If two OQL results need to be compared then two OQL editors should be opened.

   If the tables or trees are filtered then the filtered result will be used for the comparison. If there are derived data columns such calculated retained sizes then these will be included in the comparison.

2. Modify the order of the tables

   Using the tool bar of the Compare Basket one can modify the order in which tables should be compared, i.e. select which result should be the baseline, which comes second, etc...

3. Execute the comparison
   - Once the preferred order is achieved just click the execute button...

   - or to compare a subset of the tables, bring up the context menu on selected table entries. When comparing tables from one and the same heap dump, it is now possible to perform different set operations on the comparison result.
     The comparison query has several options to control the comparison in more detail.
     -mode
       Whether to show absolute values in columns, or the difference from the base table, or the difference from the preceding table.
     -setop
       Whether to just show the raw tables, or only a particular set operation, or all the tables and the set operations as context menus.
     -keycolumn
       The number of the column to be matched between the tables (default of column 1).
     -mask
       Regular expression to mask part of the key, for example addresses using: `\s@ 0x[0-9a-f]+` or an array index using `^\[[0-9]+\]$` The same object in two consecutive heap dumps may have a different address if it has been moved by garbage collection. Two corresponding objects from two different heap dumps will have different addresses. If these two objects are to matched by the comparison then the addresses need to be removed from the display value of the key. This option allows this to happen.
     -replace
       Replacement text for mask matches. This will be displayed as part of the key column. Regular expression terms `$0`, `$1` may be used to extract the value of groups defined by the mask option.
     -prefix
       Whether to include the prefix of the key column in the match — for example the field name or array index in a path.
     -suffix
       Whether to include the suffix of the key column in the match — for example the GC root type.
     -x
       The key can be extended by adding field references to be matched. The extra key values are specified as follows: extra ::= `className[:field[,field]]` Example: `java.lang.Module:name` If the object is an instance of that type then the values of those fields are resolved and added to the key. If the fields are omitted then the class specific name of the object itself is resolved.
     -xfile
       Read extra key values from the file. Each line must have the same format as for the -x argument.

   ... and see the result.

4. Customize the displayed result

   By default the absolute values of all tables will be shown for every compared property, e.g. number of objects, shallow size, etc... One can now change between deltas and absolute values, as well as select which columns should be compared:

5. Context menu with set operations

   If the tables have been compared using Compare tables and trees with all set operations then it is possible to perform different set operations on the comparison result using the context menu. Set operations only operate when there are two or more tables or trees from the current snapshot. In this situation, even if another comparison query has been chosen, then the menu toolbar contain a Choose set operation ... menu which will select which set operations appear on the context menu.

6. Comparison reports
   There are some reports which operate by comparing two snapshots. The Leak Suspects by Snapshot Comparison report available from the Overview pane runs a special Leak Suspects report which operates by comparing the dominator trees of the two snapshots and detects larger changes in retained sizes between corresponding objects. The query is also available from Leak Suspects > Compare Snapshots Leak Report and in batch mode.